#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#pragma ident   "@(#)device_config.pl 1.7     01/07/27 SMI"
#
# Device group config page
#

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Device;
use Sun::Solaris::Utils qw(gettext);

# Create the html query object
my $q = new Cluster::Cgi;
# Create a device object
my $device = new Cluster::Device;

my $step = $q->param('step');
my $devicegroup = $q->param('devicegroup');
my $func = $q->param('func');
my $primary = $q->param('primary');

# Check if in Cluster mode
if ($device->is_clustermode($q) != 0) {
        # not in cluster mode
        $device->print_nonclustermode_error($q);
        exit;
}

print $q->header();

my $menu_jscript = $q->jump_menu_jscript();
my $device_jscript = $device->device_jscript();
my $jscript = $menu_jscript . "\n" . $device_jscript .
    $q->yoke_jscript("d-$devicegroup");
# Start the document
print $q->start_html({  TITLE => gettext("Global Devices"),
			STYLE  => { 'src' => '/css/clustmgr-style.css'},
                        CLASS  => "default-body",
                        SCRIPT => $jscript
                        });

# Read the configuration and status into memory if needed
$device->get_commandoutput();

SWITCH: {
	#if ($action eq "Remove") {
	#	$device->config_remove($q, $type, $name);
	#	last SWITCH;
	#}
	if ($func eq "Offline") {
		$device->config_offline($q, $step, $devicegroup);
		last SWITCH;
	}
	if ($func eq "Online") {
		$device->config_online($q, $step, $devicegroup, $primary);
		last SWITCH;
	}
}

# End the html document
$device->footer($q);
