#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#pragma ident   "@(#)meta.pl 1.4     01/08/23 SMI"
#
# Return metaset data to java applet 
#

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Device;
use Sun::Solaris::Utils qw(gettext);

# Create the html query object
my $q = new Cluster::Cgi;

# Create the Device object
my $device = new Cluster::Device;

# Print the html header
print $q->header(-expires => "now");

# Get the nodelist
my @node_list = $device->get_nodelist();
my %node_numbers;

my $num_nodes = @node_list;
for (my $count = 0; $count < $num_nodes; $count++) {
    $node_numbers{"$node_list[$count]"} = $count;
}

# Get the list of devices
$device->get_commandoutput();
my @d_list = $device->get_devicegrouplist();

# Print the number of Devices
my $length = $#d_list + 1;
print "$length\n";

for (my $i = 0; $i < $length; $i++) {
	print "$d_list[$i]{'name'}\n";
	print "$d_list[$i]{'status'}\n";
}

for (my $i = 0; $i < $length; $i++) {
	my @temp = ();
	my @n_list = split(/,/, $d_list[$i]{'nodelist'});
	$temp[$node_numbers{$n_list[0]}] = 1;
	$temp[$node_numbers{$n_list[1]}] = 2;
	for (my $j = 0; $j < $num_nodes; $j++) {
		if ($temp[$j]) {
			print "$temp[$j]\n";
		} else {
			print "0\n";
		}
	}
}

