#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)finish_install_remote.pl	1.10	01/08/23 SMI"
#
# Find out if all of the nodes are up

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Common;

# Create a cluster object
my $cluster = new Cluster::Common;

# Create the CGI object
my $q = new Cluster::Cgi;

# Print the header
print $q->header(-expires => "now");

# Get the nodelist
my @nodelist = $cluster->get_nodelist();

# Contact each node to make sure its up in installmode
foreach my $node (@nodelist) {
    my ($installmode, $location);

    $location = "/cgi-bin/installation/install_state.pl?step=FINISH_INSTALL";
    ($installmode) = $cluster->get_http($node, 
					$cluster->get_http_port(), 
					$location, undef, 1);

    if (defined $installmode) {
	chomp $installmode;
    
	if ($installmode eq "NO") {
	    print "NO";
	    exit;
	}

    } else {
	print "NO";
	exit;
    }
}

# If everything's ok, then print it.
print "OK";

