#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)installation.pl	1.12	01/08/15 SMI"
#
# SDS Install Step 2. Call installation.ksh. Also, add root to the
# sysadmin group as recommended in the SDS docs.

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Common;

# Create the html query object
my $q = new Cluster::Cgi;

# Print the header
print $q->header();

# Fork so that we can exit to the parent immediately
if (fork()) {
    exit;
}

# Remove the BASEDIR environment variables
delete @ENV{'BASEDIR', 'CLIENT_BASEDIR'};

# Create a cluster object for logging
my $cluster = new Cluster::Common;

# Get the solaris cdrom path to give to installation.ksh
my $solaris_cdrom_path = $q->param('solaris_cdrom_path');

# Create the string to call installation.ksh with
my $installation = "/opt/SUNWscvw/cgi-bin/installation/sds/installation.ksh";
$installation .= " $solaris_cdrom_path";

# Call installation.ksh. We don't need pfexec here, since
# installation.ksh runs under pfksh.
`$installation`;

# Get return
my $ret = $?;

# Print result
if ($ret == 0) {
    $cluster->syslog("SDS Installation SUCCEEDED!");
} else {
    $cluster->syslog("SDS Installation FAILED!");
}

# Touch the file that indicates we're done
my $logdir = $cluster->get_logdir();
`touch $logdir/done_sds`;

if ($? != 0) {
    $cluster->syslog("touch $logdir/done_sds FAILED!");
}

# Add root to the sysadmin group
`/usr/bin/pfexec /usr/sbin/usermod -G sysadmin root`;

if ($? != 0) {
    $cluster->syslog("usermod -G sysadmin root FAILED!");
}

# Exit completely
CORE::exit(0);
