#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)step0.pl	1.18	01/08/14 SMI"
#
# Installation instruction page

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Install;
use Sun::Solaris::Utils qw(gettext);

# Create the html query object
my $q = new Cluster::Cgi;

# Create a install object
my $install = new Cluster::Install;

# Start the html document
$install->header($q, gettext("Sun Cluster Installation"));
print $q->p({class => "action-window-normal-text"});

# Print the form
print $q->start_form({ action => '/cgi-bin/installation/step1.pl',
			method => 'get'
			});
print $q->p({class => "action-window-normal-text"});
print gettext("This installation will take from 30 to 90 minutes, depending " .
    "on the data services you select and the number of disks used in the " .
    "cluster.  Before proceeding, ensure that the use of a proxy " .
    "in your browser has been disabled.");
print "<BR>";
print "<BR>";
print gettext("Before proceeding, you should have completed the following: ");
print "<BR>";
print "<BR>";

print "<UL>";
print "<LI> ".gettext("Solaris 8 installed on all cluster nodes with the following configuration:");
print "<UL>";
print "<LI> ".gettext("The \"End User\" or greater Solaris installation package (Note: Oracle installation requires \"Developer\" or greater.)");
print "<LI> ".gettext("The partitions of the root disk should have the following sizes and mount points:");
print "<UL>";

print "<TABLE>";
print $q->start_Tr();
print "<TD> <B>".gettext("Mount Point")."</B></TD>";
print "<TD> <B>".gettext("Disk Space")."</B></TD>";
print $q->end_Tr();

print $q->start_Tr();
print "<TD>/</TD>";
print "<TD>".gettext("free")."</TD>";
print $q->end_Tr();

print $q->start_Tr();
print "<TD>".gettext("swap")."</TD>";
print "<TD>".gettext("750 MB")."</TD>";
print $q->end_Tr();

print $q->start_Tr();
print "<TD>/globaldevices</TD>";
print "<TD>".gettext("100 MB")."</TD>";
print $q->end_Tr();

print $q->start_Tr();
print "<TD>/sds</TD>";
print "<TD>".gettext("10 MB (only needed if you install Solstice DiskSuite)</TD>");
print $q->end_Tr();

print "</TABLE>";
print "</UL>";
print "</UL>";

print "<LI> ".gettext("Sun Cluster 3.0 CD mounted on a filesystem accessible to all nodes.");
print "<BR>";

print "<LI> ".gettext("Solaris 8 CD mounted on a filesystem accessible to all nodes if you're installing Solstice DiskSuite.");
print "<BR>";

print "<LI> ".gettext("Sun Cluster 3.0 Data Services CD mounted on a filesystem accessible to all nodes if you're installing Scalable Apache or HA NFS.");
print "<BR>";

print "<LI> ".gettext("If you're using SunPlex Manager to automatically add patches, a directory with the patches accessible to all nodes.  Otherwise, you must manually add any needed patches on all nodes.");
print "<BR>";

print "<LI> ".gettext("Determined the list of interconnects between the nodes.");
print "<LI> ".gettext("If you're installing Scalable Apache and/or HA NFS, determined the logical address(es) which will be used.");
print "</UL>";

$install->start_button_table($q);
print $q->submit({ name  => 'submit_step_1',
		    value => gettext("  Next >  ")
		    });
$install->end_button_table($q);
print $q->end_form();

# End the html document
$install->footer($q);
