#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#pragma ident	"@(#)network_view.pl 1.9	01/07/27 SMI"
#
# Network view page
#

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Network;
use Sun::Solaris::Utils qw(gettext);

# Create the html query object
my $q = new Cluster::Cgi;

# Create a network object
my $network = new Cluster::Network;

# Get the parameters
my $node = $q->param("node");
my $nafogroup = $q->param("nafogroup");

# Print the query header and make the page expire now
print $q->header(-expires => "now");

# Start the document
print $q->start_html({  TITLE => gettext("View Network"),
			STYLE  => { 'src' => '/css/clustmgr-style.css'},
                        CLASS  => "default-body",
                        SCRIPT => "top.helpMarker=\"network_view-top\"\n" . $q->jump_menu_jscript() . $q->yoke_jscript("nf-$node")
                        });

if (!defined $nafogroup) {
	$network->network_header($q,
	    [gettext("Nodes"), "/cgi-bin/node/node_status.pl",
	    $node, "/cgi-bin/node/node_info.pl?node=$node",
	    gettext("NAFO Groups")], $node);
	$network->nafogroups_table($q, $node);
} else {
	$network->network_header($q,
	    [gettext("Nodes"), "/cgi-bin/node/node_status.pl",
	    $node, "/cgi-bin/node/node_info.pl?node=$node",
	    gettext("NAFO Groups"),
		"/cgi-bin/network/network_view.pl?node=$node",
	    $nafogroup], $node, $nafogroup);
	$network->nafo_table($q, $node, $nafogroup);
}

# 
# End the html document
$network->footer($q);
