#!/usr/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)rs_add.pl	1.17	01/07/27 SMI"
#
# add resource
#
use lib '/opt/SUNWscvw/lib/perl';
use Socket;
use Cluster::common;
use Cluster::scrgcommon;
use strict;
use Sun::Solaris::Utils qw(gettext);

&do_page([gettext("Resource Groups"), "/cgi-bin/rg/rg_view.pl",
    gettext("Create New Resource")]);

exit;

sub cmd_mainpage {
    my $i;

    &wizard_start;
    print $q->_script($q->yoke_jscript("rg"));
    &getscrgconfig();

    my $rg_name = $q->param("rg");

    if ($errpos == 1) {
	&errmsg();
    }

    &action_table_start();
    &action_table_row_start(gettext("Resource Type:"));
    &typeselect();
    &action_table_row_end();

    &getlh("anything");
    &action_table_row_start(gettext("Associated network resource:"));
    print "<select name=\"lh\">\n";
    &option("lh", join(":", "", "", "", "--none--"), gettext("--none--"));
    for ($i = 0; $i <= $#lh; $i++) {
	&option("lh", join(":", $lh[$i], $lhrg[$i], $lhrs[$i], "lh"), $lhrs[$i]." (lh)");
    }
    for ($i = 0; $i <= $#sa; $i++) {
	&option("lh", join(":", $sa[$i], $sarg[$i], $sars[$i], "sa"), $sars[$i]." (sa)");
    }
    print "</select>\n";
    &action_table_row_end();

    &action_table_row_start(gettext("Configure Additional Properties?"));
    &checkbox("allparams", "yes", gettext("Yes"));
    &action_table_row_end();

    &action_table_end();

    print $q->hidden({NAME => "cmd_params", VALUE => 1});
    print $q->hidden({NAME => "rg", VALUE => $rg_name});
    (new Cluster::Rg)->submit_button($q, gettext(" Continue "), "cancel");
}

# Next part of configuration
sub cmd_params {
    my $i;
 
    &wizard_start;
    print $q->_script($q->yoke_jscript("rg"));
    &getscrgconfig();

    if ($FORM{"rt"} eq "") {
	&errpage(gettext("Type must be specified."), 1, "cmd_mainpage");
    }

    if (! &checktype($FORM{"rt"})) {
	return;
    }

    my ($lh, $lhrg, $lhrs, $lhmode) = split(/:/, $FORM{"lh"});

    &getrtprops($FORM{"rt"});

    my $mode = "none";

    if ($FORM{"rt"} eq "SUNW.SharedAddress") {
	$mode = "sa";
    } elsif ($FORM{"rt"} eq "SUNW.LogicalHostname") {
	$mode = "lh";
    }
    if ($lhmode eq "--none--") {
	# Keep previous $mode
    } elsif ($lhmode eq "sa") {
	if ($rtvar{"failover"} eq "True") {
	    &errpage(sprintf(gettext("Type %s cannot be scalable"), $FORM{"rt"}), 2, "cmd_mainpage");
	}
	if ($mode eq "none") {
	    $mode = "scalable";
	} else {
	    &errmsg(sprintf(gettext("%s: ignoring specified network group"), $FORM{"rt"}));
	}
    } elsif ($lhmode eq "lh") {
	if ($mode eq "none") {
	    $mode = "failover";
	} else {
	    &errmsg(sprintf(gettext("%s: ignoring specified network group"), $FORM{"rt"}));
	}
    } else {
	&errmsg(sprintf(gettext("Unexpected lhmode %s"), $lhmode));
    }

    &getnodes();

    if ($errpos == 1) {
	&errmsg();
    }
    &action_table_start();

    if ($errpos == 103) {
	&errmsg();
    }

    if ($mode eq "lh" || $mode eq "sa" || $mode eq "none" ||
		$mode eq "scalable") {
	&action_table_row_start(gettext("Resource Group To Hold Resource:"));
	print "<select name=\"rg\">\n";
	&option("rg", "--new--", gettext("--new--"));
	foreach $i (sort keys %rgdesc) {
	    &getrgprops($i);
	    if ($rgprops{"mode"} eq "Scalable") {
		if ($mode eq "lh" || $mode eq "sa") {
		    # Skip it
		} elsif ($mode eq "scalable") {
		    if ($rgprops{"RG_dependencies"} eq $lhrg) {
			&option("rg", $i, $i);
		    }
		} else {
		    &option("rg", $i, sprintf(gettext("%s (scalable)"), $i));
		}
	    } elsif ($rgprops{"mode"} eq "Failover") {
		if ($mode eq "lh" || $mode eq "sa") {
		    &option("rg", $i, $i);
		} elsif ($mode eq "scalable") {
		    # Skip it
		} else {
		    &option("rg", $i, sprintf(gettext("%s (failover)"), $i));
		}
	    } else {
		&errmsg(sprintf(gettext("Unexpected mode %s"), $rgprops{"mode"}));
	    }
	}
	print "</select>\n";
	&action_table_row_end();

	if ($errpos == 1) {
	    &errmsg();
	}
	&action_table_row_start(gettext("Resource Group Name (if new):"));
	&input("rgname");
	&action_table_row_end();
    }

    if ($FORM{"rs"} eq "") {
	# Find a resource name that is not in use
	for ($i = ""; $i<10; $i++) {
	    $FORM{"rs"} = "resource$i";
	    if (! defined $rsdesc{$FORM{"rs"}}) {
		last;
	    }
	    $FORM{"rs"} = "";
	}
    }


    if ($FORM{"action"} eq "") {
	$FORM{"action"} = "create";
    }
    if ($mode eq "lh") {
	&action_table_row_start(gettext("Action:"));
	print "<select name=\"action\">\n";
	&option("action", "create", gettext("Create Logical Hostname"));
	&option("action", "start", gettext("Create and start"));
	print "</select>\n";
	&action_table_row_end();
    }  elsif ($mode eq "sa") {
	&action_table_row_start(gettext("Action:"));
	print "<select name=\"action\">\n";
	&option("action", "create", gettext("Create Shared Address"));
	&option("action", "start", gettext("Create and start"));
	print "</select>\n";
	&action_table_row_end();
    } elsif ($mode eq "failover") {
	&action_table_row_start(gettext("Name for New Resource:"));
	&input("rs");
	&action_table_row_end();

	&action_table_row_start(gettext("Action:"));
	print "<select name=\"action\">\n";
	&option("action", "create", gettext("Create failover resource"));
	&option("action", "start", gettext("Create and start"));
	print "</select>\n";
	&action_table_row_end();
    } elsif ($mode eq "scalable") {
	&action_table_row_start(gettext("Name for New Resource:"));
	&input("rs");
	&action_table_row_end();

	&action_table_row_start(gettext("Action:"));
	print "<select name=\"action\">\n";
	&option("action", "create", gettext("Create scalable resource"));
	&option("action", "start", gettext("Create and start"));
	print "</select>\n";
	&action_table_row_end();
    } elsif ($mode eq "none") {
	&action_table_row_start(gettext("Name for New Resource:"));
	&input("rs");
	&action_table_row_end();

	&action_table_row_start(gettext("Action:"));
	print "<select name=\"action\">\n";
	&option("action", "create", gettext("Create resource"));
	&option("action", "start", gettext("Create and start"));
	print "</select>\n";
	&action_table_row_end();
    } else {
	&errmsg(sprintf(gettext("Unexpected mode %s"), $mode));
    }

    # Properties heading
    print "<tr><td nowrap colspan=2><div class =\"action-window-label-text\">";
    print gettext("Properties:");
    print "</div></td></tr>\n";

    &proptable(0, $lhmode);
    #print "</td></tr>\n";
    &action_table_end();

    &hidden("rg");
    &hidden("rt");
    &hidden("lh");
    &hidden("type");
    $FORM{"mode"} = $mode;
    &hidden("mode");
    print $q->hidden({NAME => "allparams"});
    print $q->hidden({NAME => "cmd_create", VALUE => 1});
    (new Cluster::Rg)->submit_button($q, gettext(" Create Resource "),
	"cancel");
    &wizard_end();
}

sub cmd_create {

    &wizard_start;
    if ($FORM{"rg"} eq "--new--") {
	print $q->_script($q->yoke_jscript("rg"));
    } else {
	print $q->_script($q->yoke_jscript("rg-".$FORM{"rg"}));
    }
    &getscrgconfig();
    &getrtprops($FORM{"rt"});


    my $args;
    my $status;
    my ($lh, $lhrg, $lhrs, $lhmode) = split(/:/, $FORM{"lh"});
    my $mode = $FORM{"mode"};

    if ($mode eq "lh" || $mode eq "sa" || $mode eq "none" ||
		$mode eq "scalable") {
	if ($FORM{"rg"} eq "--new--") {
	    if ($FORM{"rgname"} eq "") {
		&errpage(gettext("Resource group name must be specified."), 1, "cmd_params");
	    } elsif (defined $rgdesc{$FORM{"rg"}}) {
		&errpage(gettext("Resource group already exists."), 1, "cmd_params");
	    }
	}
    }

    if ($mode eq "lh" || $mode eq "sa") {
	if ($FORM{"prop_HostnameList"} eq "") {
	    &errpage(gettext("Property HostnameList must be specified"), 200, "cmd_params");
	}
	($FORM{"rs"} = $FORM{"prop_HostnameList"}) =~ s/,.*//;
    }

    if ($FORM{"rs"} eq "") {
	&errpage(gettext("Resource name must be specified."), 103, "cmd_params");
    } elsif (defined $rsdesc{$FORM{"rs"}}) {
	&errpage(sprintf(gettext("Resource %s in use"), $FORM{"rs"}), 103, "cmd_params");
    }

    if ($mode eq "scalable") {
	$lhmode = "sa";
    } else {
	$lhmode = "lh";
    }

    if ($mode eq "lh") {
	$args = " -L -l ".$FORM{"prop_HostnameList"};
	if ($FORM{"prop_NetIfList"} ne "") {
	    $args .= " -n ".$FORM{"prop_NetIfList"};
	}
    } elsif ($mode eq "sa") {
	$args = " -S -l ".$FORM{"prop_HostnameList"};
	if ($FORM{"prop_NetIfList"} ne "") {
	    $args .= " -n ".$FORM{"prop_NetIfList"};
	}
    } else {
	$args = " -t ".$FORM{"rt"};
	if ($mode eq "failover" || $mode eq "scalable") {
	    $args .= " -y Network_resources_used=$lh";
	}
    }

    if ($mode eq "failover" || $mode eq "none") {
	$FORM{"prop_Scalable"} = "False";
    }

    my $i;
    foreach $i (keys %FORM) {
	if ($i =~ /^prop_(.*)/) {
	    my $prop = $1;
	    if (! defined $rttable{$prop, "extension"}) {
		# Property isn't defined in the rt
		next;
	    }

	    if ($FORM{$i} eq "" && (! defined $rttable{$prop, "default"}) &&
		    $rttable{$prop, "extension"} eq "True") {
		if ($rttable{$prop, "type"} eq "Stringarray") {
		    # Stringarray null defaults don't show up in scrgadm.
		    # Thus, this may be okay
		} else {
		    &errpage(sprintf(gettext("Property %s must be specified"), $prop), 200, "cmd_params");
		}
	    }
	    if ($FORM{$i} eq $rttable{$prop, "default"} || $FORM{$i} eq "") {
		next; # Use the default value
	    }

	    if ($FORM{$i} eq "NULL") { # i.e. <NULL> with angles stripped off.
		if ($rttable{$prop, "default"} eq "<NULL>") {
		    next; # Use the default value
		} else {
		    $FORM{$i} = ""; # Pass empty arg to scrgadm for NULL
		}
	    }

	    if ($rttable{$prop, "extension"} eq "True") {
		if ($mode ne "sa" && $mode ne "lh") {
		    $args .= " -x $prop=".$FORM{$i};
		}
	    } else {
		$args .= " -y $prop=".$FORM{$i};
	    }
	}
    }

    my $cmd;

    if ($mode eq "lh" || $mode eq "sa" || $mode eq "none") {
	# Create new resource group
	if ($FORM{"rg"} eq "--new--") {
	    $FORM{"rg"} = $FORM{"rgname"};
	    $cmd = "scrgadm -a -g ".$FORM{"rg"};
	    $status = &runsuid($cmd);
	    if ($status) {
		if ($result =~ /resource group exists/) {
		    $result = gettext("The resource group already exists");
		    &errmsg($result, 0);  ### must I18nize $result
		} else {
		    # Arbitrary error result; can't i18n
		    &errmsg(gettext("Failure"), $result);
		    return $status;
		}
	    }
	}
    }

    if ($mode eq "scalable") {
	if ($FORM{"rg"} eq "--new--") {
	    $FORM{"rg"} = $FORM{"rgname"};
	    $lhmode = "sa";
	} else {
	    # Don't create the resource group
	    $lhmode = "sanocreate";
	}
	# $lhrg defined
    } else {
	$lhmode = "lh";
	if ($mode eq "failover") {
	    # $lhrg defined
	} else {
	    $lhrg = $FORM{"rg"};
	}
    }

    $FORM{"lh"} = join(":", $lh, $lhrg, "", $lhmode);

    if ($FORM{"action"} eq "create") {
	# Create only
	$status = &createservice($args, 1);
	if ($status) {
	    &wizard_end();
	    (new Cluster::Rg)->view_button($q);
	    return;
	} else {
	    &reloadmenu($q);
	    print $q->_script($q->yoke_jscript("rg-rs-".$FORM{"rs"}));
	}
	&okmsg(gettext("Resource created"));
    } else {
	# Create and start
	$status = &createservice($args);
	if (! $status) {
	    &reloadmenu($q);
	    print $q->_script($q->yoke_jscript("rg-rs-".$FORM{"rs"}));
	}
    }
    &wizard_end();
    (new Cluster::Rg)->view_button($q);
}
